import Vuex, {Store, StoreOptions} from 'vuex';
import {VuexModule, VuexStoreConfig} from "../interface";

export class Service {

    constructor(vuexStoreConfig: VuexStoreConfig = {}) {
        this.vuexStoreConfig = vuexStoreConfig || {};
    }

    private readonly vuexStoreConfig: VuexStoreConfig;

    public addModule(vuexModule: VuexModule): void {
        if(!this.vuexStoreConfig.modules) this.vuexStoreConfig.modules = {};
        //@ts-ignore
        Object.assign(this.vuexStoreConfig.modules, vuexModule)
    }

    public createStore(): Store<any> {
        return new Vuex.Store(this.vuexStoreConfig);
    }
}

const store = new Service();
store.addModule({});
store.createStore();

